/*
	desc      : Mongoose Embedded Web Server 'C' Plugin
	author    : Raphael Smart
	date      : May 2012

	licence/disclaimer:

	This software is provided 'as-is', without any express or implied warranty.
	In no event will the author be held liable for any damages arising from
	the use of this software.
*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#ifndef _WIN32
#include <unistd.h>
#endif

#include "mongoose.h"

#define __MODULENAME__ "test_c_plugin"


static const char *STANDARD_HTML_REPLY = "HTTP/1.1 200 OK\r\n"
  "Content-Type: text/html\r\n"
  "Connection: close\r\n\r\n";

void test_c_plugin_init()
{
	printf("init test_c_plugin '%s'\n", __MODULENAME__);
}

void test_c_plugin_exit()
{
	printf("exit test_c_plugin '%s'\n", __MODULENAME__);
}

void test_c_plugin(struct mg_connection *conn, const struct mg_request_info *ri) 
{
	mg_write(conn,  STANDARD_HTML_REPLY, strlen(STANDARD_HTML_REPLY));
	mg_printf(conn, "<h3>Hello World From '%s'<h3>", __MODULENAME__);
}
