/*
	desc      : Mongoose Embedded Web Server HTML Template Plugin
	author    : Raphael Smart
	date      : May 2012

	licence/disclaimer:

	This software is provided 'as-is', without any express or implied warranty.
	In no event will the author be held liable for any damages arising from
	the use of this software.
*/
constant __MODULENAME__ = "test_mtml_plugin"

enum 

	false = 0,
	true

include std/rand.e as r
include std/map.e
include std/io.e

include lib/libmongoose.e as mg

constant WORDLIST  = read_lines("data/ewords.txt")
constant WORDCOUNT = length(WORDLIST)

export procedure test_mtml_plugin_init()
	printf(1, "init test_mtml_plugin '%s'\n", { __MODULENAME__ })
end procedure

export procedure test_mtml_plugin_exit()
	printf(1, "exit test_mtml_plugin '%s'\n", { __MODULENAME__ })
end procedure

export procedure test_mtml_plugin(atom conn, atom ri)
	sequence rqi = mg:parse_request(conn, false)
	object num_words = mg:get_var(mg:kvget(rqi, "query_string"), "num_words")
	num_words = value(num_words)
	num_words = num_words[$]
	if not num_words then
		num_words = 20
	end if 
	mg:write(conn, mg:STANDARD_HTML_REPLY)
	mg:write(conn, dotemplate(num_words))
end procedure

function dotemplate(integer n=10)
	sequence wordlist={}
	for i = 1 to n do
		wordlist &= { WORDLIST[rand_range(1, WORDCOUNT)] }
	end for
	map words = map:new()
	map:put(words, "words", wordlist)
	return template(words)
end function
--// enable html script syntax highlighting

function template(map:map data, map:map params=map:new())
	sequence result = ""

			result &= `
`
	result &= `
`
sequence words = map:get(data, "words", "") 
integer  wordcount = length(words)
if not wordcount then
	return ""
end if
	result &= `
<html>
<body>
<h1>Displaying `
	result &= sprintf("%d", { wordcount })
	result &= ` random words (click refresh to regenerate list)</h1></br>
<ul>
`
for i = 1 to wordcount do
	result &= `
	<li>`
	result &= sprintf("%s", { words[i] })
	result &= `</li>
`
end for
	result &= """
</ul>
</body>
</html>
"""
		return result
	end function
	
